	;---------------------------------------------------
	;---------------------------------------------------
	; Crystal Volleyball
	; by Ben Rhoades (ben AT loirak DOT com)
	;---------------------------------------------------
	; http://www.loirak.com/ - A site of mine
	;---------------------------------------------------
	; Why? Because I needed to do some low level coding
	; and I love the NES. I have three in my closet!
	;
	; How? By reading some tech documents. Thanks to 
	; the following resources. 
	;
	; http://nesdev.parodius.com/
	; - NESTECH.TXT 2.0 by Jeremy Chadwick
	; - RTK's Assembly In One Step
	; 
	; http://k2pts.home.comcast.net/gbaguy/nesasm.htm
	; - Gbaguy's NES ASM Tutorial 
	;---------------------------------------------------
	; Programs Used:
	;     Graphics
	;		 TileLayerPro by Kent Hansen (SnoBro)
	;        Palette Editor by joker21
	;     Editor
	;        Crimson Editor (w/6502 highlighting)
	;     Assembler 
	;        NESASM by Charles Doty, 
	;                  David Michel, 
	;                  and J.H. Van Ornum
	;     Emulator 
	;        FCEUltra
	;        Nintendulator by Quitust,
	;                         and David de Regt
	;---------------------------------------------------
	; Progress 2005 
	;     Mar 19-25 - Document Reading
	;     Mar 26 - Concept/Bullseye
	;     Mar 27 - Title Screen
	;     Apr 9 - Initial Sounds
	;     Apr 9 - InBox detection
	;     Aug 16 - Changed Game Idea 
	;            - drew characters
	;     Aug 25 - coded Drawing Chars
	;     Sep 15 - Made Chars move
	;            - ball bounces of wall/ceiling           
	;            - algorythm for collision (uncoded)
	;     Sep 16 - collision coded
	;            - sound added (hit/miss/wall/ceiling)
	;            - add gameover/text, also holdstart
	;            - does score keeping
	;            - win screen
	;     ALPHA  - Sep 16
	;     Nov 7  - worked on konami (got code working)
	;     Nov 11 - got easter egg screen in/and/working
	;     Nov 19 - drk421 reports non working on REAL NES
	;     Nov 21 - added init code/register/variable
	;
	; TODO
	;     - test on real nes
	;     COMMENT: testing on a real nes, I should make
	;        sure about the TV resolution because the 
	;        ball and player need to be visible, they
	;        should not go off the screen and then 
	;        reappear that would be bad!
	;---------------------------------------------------
	;---------------------------------------------------
	
	;---------------------------------------------------
	; INES header stuff
	;---------------------------------------------------
	.inesprg 1 		  ; 1 bank of code
	.ineschr 1  	  ; 1 bank of spr/bkg data
	.inesmir 1  	  ; something always 1
	.inesmap 0   	  ; mapper 0
	;---------------------------------------------------

	;---------------------------------------------------
	.bank 1   		  ; following goes in bank 1
	.org $FFFA        ; start at $FFFA
	;---------------------------------------------------
	.dw 0             ; NMI routine
	.dw Start         ; give address of start of our code for execution on reset of NES.
	.dw 0             ; VBlank interrupt handler
	;---------------------------------------------------

	;---------------------------------------------------
	.bank 0           ; bank 0 - our place for code.
	;---------------------------------------------------
	.org $0000		  ; Variable Storage
	;---------------------------------------------------
addrLO:	.db 0  ; make "variable"s for our indirect addressing
addrHI: .db 0	
ballDIR:.db 0  ; variable holding direction of the ball, balls x/y in sprites
useralive: .db 0	; 1 if user is alive, 0 is they are dead and we are waiting for them to press start
holdingstart: .db 0 	; 1 if we are waiting for them to release start, 0 otherwise
konamistate:	.db	0	; 0 value reset to this after wrong keypress when another value had
                        ; sequence for konami code up (1), up (2), down (3), down (4), 
                        ; left (5), right (6), left (5), right (7), b (8), a (9), start (10)
                        ; (debug : $0005)
konamikey:  .db 0    ; which of the keys they are holding down 8=UP, 2=DOWN, 6=RIGHT, 4=LEFT, B=7, A=9, START=5
konamilastkey: .db 0 ; store the last key pressed (from previous vlank)
pressingstart: .db 0 ; used as return for konami key function					 
debugvar: .db 0      ; used for debug bp ($0009) - set as breakpoint on write in fceu
showhidden: .db 0    ; var for mainloop do go into hidden screen display
	
	;---------------------------------------------------
	.org $0300		  ; Sprite RAM (initialization does
	; 				    not work here as it is RAM -> Shows how stupid I am
	;---------------------------------------------------
sprmemory:
spr0y:  .db 0  ; sprite 0-3 was the bullseye, will probably be the score
spr0t:  .db 0  
spr0s:  .db 0        
spr0x:  .db 0 
spr1y:  .db 0 
spr1t:  .db 0  
spr1s:  .db 0 
spr1x:  .db 0 
spr2y:  .db 0  
spr2t:  .db 0  
spr2s:  .db 0 
spr2x:  .db 0 
spr3y:  .db 0 
spr3t:  .db 0  
spr3s:  .db 0 
spr3x:  .db 0 
bally:         ; sprite 4 is the ball
spr4y:  .db 0  
spr4t:  .db 0  
spr4s:  .db 0 
ballx:
spr4x:  .db 0 
playery:
spr5y:  .db 0  ; sprite 5,6,7,8,9,10 is the volleyball player
spr5t:  .db 0  
spr5s:  .db 0 
playerx:
spr5x:  .db 0 
spr6y:  .db 0  
spr6t:  .db 0  
spr6s:  .db 0 
playermiddlex:
spr6x:  .db 0 
spr7y:  .db 0  
spr7t:  .db 0  
spr7s:  .db 0 
spr7x:  .db 0 
spr8y:  .db 0  
spr8t:  .db 0  
spr8s:  .db 0 
spr8x:  .db 0 
spr9y:  .db 0  
spr9t:  .db 0  
spr9s:  .db 0 
spr9x:  .db 0 
spr10y:  .db 0  
spr10t:  .db 0  
spr10s:  .db 0 
spr10x:  .db 0 
spr11y:  .db 0 ; sprites 11-19 are the text at bottom of screen (SCORExxx/GAMEOVER)
spr11t:  .db 0  
spr11s:  .db 0 
spr11x:  .db 0 
spr12y:  .db 0  
spr12t:  .db 0  
spr12s:  .db 0 
spr12x:  .db 0 
spr13y:  .db 0  
spr13t:  .db 0  
spr13s:  .db 0 
spr13x:  .db 0 
spr14y:  .db 0  
spr14t:  .db 0  
spr14s:  .db 0 
spr14x:  .db 0 
spr15y:  .db 0  
spr15t:  .db 0  
spr15s:  .db 0 
spr15x:  .db 0 
spr16y:  .db 0  
score100s:
spr16t:  .db 0  
spr16s:  .db 0 
spr16x:  .db 0 
spr17y:  .db 0  
score10s:
spr17t:  .db 0  
spr17s:  .db 0 
spr17x:  .db 0 
spr18y:  .db 0  
score1s:
spr18t:  .db 0  
spr18s:  .db 0 
spr18x:  .db 0 

	; ... for all the sprites we will use more later I am sure
	
	;---------------------------------------------------
	.org $8000  ; code starts at $8000 (PRG-ROM)
	;---------------------------------------------------
	
Start:  

	; Setup The Palette	
	ldx #$00    ; clear X

	lda #$3F    ; have $2006 tell
	sta $2006   ; $2007 to start
	lda #$00    ; at $3F00 (pallete).
	sta $2006

loadpal:            ; this is a freaky loop
	lda tilepal, x  ; that gives 32 numbers
	sta $2007       ; to $2007, ending when
	inx             ; X is 32, meaning we
	cpx #32         ; are done.
	bne loadpal     ; if X isn't =32, goto "loadpal:" line.

turnonsound:
	lda #%00000001	; turn on square wave channel 1
	sta $4015
	
	lda #0
	sta holdingstart
	
dotitlescreen:
	jsr displaytitlescreen
	jsr turnonppunosprites	
	
	lda #3			; have the initial direction of the ball be downleft
	sta ballDIR
	lda #1 			; set the user alive
	sta useralive
	lda #0
	sta konamistate  ; reset the current place in code to zero
    sta konamilastkey
    sta showhidden
	
;-----------------------------------
; TITLE SCREEN LOOP (waitstartblank)
;-----------------------------------
	
waitstartblank:          ; this is the wait for VBlank code from above
	lda $2002            ; load A with value at location $2002
	bpl waitstartblank   ; if bit 7 is not set (not VBlank) keep checking

	jsr processkonamicode ; do keyboard input and test for konami code

	lda pressingstart	; they are pressing start
	bne posttitlescreen
	lda #0				; they are not holding start so reset the variable
	sta holdingstart
	jmp waitstartblank
	
posttitlescreen:
	lda showhidden
	bne dohiddenscreen
	lda holdingstart    ; are they still holding start
	bne waitstartblank
	jsr playtitlesound		
	jsr turnoffppu
	jsr clearscreen	
	jsr setup_game  ; setup sprites	
	jsr turnonppuwithsprites
	jmp waitblank

;-------------------------------------
; HIDDEN SCREEN LOOP (waithiddenblank)
;-------------------------------------
dohiddenscreen:
    lda #0
    sta showhidden
    sta debugvar
	jsr turnoffppu
	jsr clearscreen	
	jsr displayhiddenscreen
	jsr turnonppunosprites	

waithiddenblank:          
	lda $2002            
	bpl waithiddenblank
	; do logic for start here
	; Read the Controllers
	lda #$01    ; |
	sta $4016   ;  \
	lda #$00    ;   - Setup Pad for reading.
	sta $4016   ; _/

	lda $4016  ; read for A key.
	lda $4016  ; read for B key.
	lda $4016  ; read for SELECT
	lda $4016  ; read START status
	and #1
	bne posthiddenscreen
	lda #0				; they are not holding start so reset the variable
	sta holdingstart
    jmp waithiddenblank
    
posthiddenscreen:
	lda holdingstart 
	bne waithiddenblank
	lda #1
	sta holdingstart ; reset the hold start var
	jsr playmisssound
	jsr turnoffppu
	jsr clearscreen	
	jmp dotitlescreen
	
;---------------------------
; MAIN GAME LOOP (waitblank)
;---------------------------
	
waitblank:          ; this is the wait for VBlank code from above
	lda $2002       ; load A with value at location $2002
	bpl waitblank   ; if bit 7 is not set (not VBlank) keep checking


	lda #3			; sprite's are at $0300
	sta $4014		; do a sprite DMA copy
	
	; Read the Controllers
	lda #$01    ; |
	sta $4016   ;  \
	lda #$00    ;   - Setup Pad for reading.
	sta $4016   ; _/

	lda $4016  ; read for A key.
	lda $4016  ; read for B key.
	lda $4016  ; read for SELECT
	lda $4016  ; read START status
	and #1
	bne PressedStart
ReturnStart:	
	lda $4016  ; read UP
	lda $4016  ; read DOWN
	lda $4016  ; read LEFT
	and #1
	bne MoveLeft
ReturnLeft:
	lda $4016  ; read RIGHT
	and #1
	bne MoveRight
ReturnRight:
	jmp StartMoveBall
MoveLeft:
	lda spr5x
	beq ReturnLeft
	dec spr5x
	dec spr6x
	dec spr7x
	dec spr8x
	dec spr9x
	dec spr10x
	jmp ReturnLeft

MoveRight:
	ldx #240
	cpx spr5x
	beq ReturnRight
	inc spr5x
	inc spr6x
	inc spr7x
	inc spr8x
	inc spr9x
	inc spr10x
	jmp ReturnRight

PressedStart:
	lda useralive		; is user alive, otherwise keep them playing
	bne ReturnStart
	; need to add something so that we wait till the release the start button before starting the game again
	lda #1
	sta holdingstart
	jsr turnoffppu
	jmp dotitlescreen

	; End Character reading code
	
	; move the ball 
	; need a variable that controls the direction of the ball
	; POSSIBLE DIRECTIONS: up left, up, up right, down left, down, down right
	; VARIABLE DEFINES   :       0,  1,        2,         3,    4,          5
	
	; After thinking about have 6 directions, it makes no sense, if the person can get 
	; the ball to go straight up or straight down, then they will never have to move
	; their character and their score will increase indefintely. I will leave the code
	; currently in place alone, and just make sure up/down are never set, when the player
	; hits the ball 
StartMoveBall:
	lda useralive
	bne ActualMoveBall
	; user is dead, skip ball movement
	jmp EndMoveBall
	
ActualMoveBall
	ldx #0
	cpx ballDIR
	beq MoveUpLeft
	ldx #1
	cpx ballDIR
	beq MoveUp
	ldx #2
	cpx ballDIR
	beq MoveUpRight
	ldx #3
	cpx ballDIR
	beq MoveDownLeft
	ldx #4
	cpx ballDIR
	beq MoveDown
	ldx #5
	cpx ballDIR
	beq MoveDownRight
	
EndMoveBall:
	jsr doballtesting
	jmp waitblank   ; JuMP to infin. note that this loop never ends. :)
	
MoveUpLeft:
	dec ballx
	dec bally
	jmp EndMoveBall

MoveUp:
	dec bally
	jmp EndMoveBall

MoveUpRight:
	inc ballx
	dec bally
	jmp EndMoveBall

MoveDownLeft:
	dec ballx
	inc bally
	jmp EndMoveBall

MoveDown:
	inc bally
	jmp EndMoveBall

MoveDownRight:
	inc ballx
	inc bally
	jmp EndMoveBall
		
	;---------------------------------------------------
	; End of looping type code
	;---------------------------------------------------

;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
; SUB ROUTINE CODE BELOW	
;-------------------------------------------------------------------------
;-------------------------------------------------------------------------
	
	
setup_game:
	; perhaps as input x = level (later on to add)
	; Initial Object Placement	
	; sprites 0-3 were the bullseye, now they are unused
	; setup up the ball's coordinates
	ldx #135	; x for ball
	ldy #10     ; y for ball
	stx spr4x
	sty spr4y
	ldx #24     ; sprite number for ball
	stx spr4t
	dex 
	stx spr4s
	
	; put the volleyballer on the screen
	; y coodinates first
	ldy #180
	sty spr5y
	sty spr6y
	ldy #188
	sty spr7y
	sty spr8y
	ldy #196
	sty spr9y
	sty spr10y
	; x coordinates
	ldx #20
	stx spr5x
	stx spr7x
	stx spr9x
	ldx #28
	stx spr6x
	stx spr8x
	stx spr10x
	; the tiles 
	ldx #11
	stx spr5t
	inx 
	stx spr6t
	ldx #27
	stx spr7t
	inx 
	stx spr8t
	ldx #43
	stx spr9t
	inx 
	stx spr10t
	; clear the funky bit I know nothing about (does flipping and colors)
	ldx #0
	stx spr5s
	stx spr6s
	stx spr7s
	stx spr8s
	stx spr9s
	stx spr10s
    ; have text / score ability under the bottom platform the player moves along
    ; since I'm too lazy to do a background it will all be in sprites
    ; "SCORE 000" or "GAME OVER" - possible uses, so 9 sprites (how many is Nintendo? 64)
	ldx #0
	stx spr11s
	stx spr12s
	stx spr13s
	stx spr14s
	stx spr15s
	stx spr16s
	stx spr17s
	stx spr18s
	; setup the coordinates
	ldy #216		; y is 216 for all the characters
					; NES has max 8 spr per line
	sty spr11y
	sty spr12y
	sty spr13y
	sty spr14y
	sty spr15y
	sty spr16y		
	sty spr17y
	sty spr18y
	lda #92
	sta spr11x
	adc #8
	sta spr12x
	adc #8
	sta spr13x
	adc #8
	sta spr14x
	adc #8
	sta spr15x
	adc #8
	sta spr16x
	adc #8
	sta spr17x
	adc #8
	sta spr18x
	ldx #83			; S is 83d	
	stx spr11t
	ldx #67			; C is 67d
	stx spr12t
	ldx #79			; O is 79d
	stx spr13t
	ldx #82			; R is 82d
	stx spr14t
	ldx #69			; E is 69d
	stx spr15t
    ; adjusted this for test rollover/winning 989 - 57, 56, 57
	ldx #48			; 0 is 48d
	stx spr16t
	ldx #48			; 0 is 48d
	stx spr17t
	ldx #48			; 0 is 48d
	stx spr18t
	rts
	;---------------------------------------------------
dokonamistatemachine:
; function above does the state machine based on konamikey
; added kpart stuff to keep the branches in range
kstate0:
    ldx #0
    cpx konamistate ; state none
    bne kstate1
    ldy konamilastkey
    cpy #8 ; pressed up
    beq kpart0
    jmp resetstate
kpart0:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate1:
    ldx #1
    cpx konamistate ; state up
    bne kstate2
    ldy konamilastkey
    cpy #8 ; pressed up
    beq kpart1
    jmp resetstate
kpart1:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate2:    
    ldx #2
    cpx konamistate ; state up up 
    bne kstate3
    ldy konamilastkey
    cpy #2 ; pressed down
    beq kpart2
    ldy konamilastkey
    cpy #8 ; pressed up again (stay in state up up)
    beq kstate3
    jmp resetstate
kpart2:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate3:
    ldx #3
    cpx konamistate ; state up up down
    bne kstate4
    ldy konamilastkey
    cpy #2 ; pressed down
    beq kpart3
    jmp resetstate
kpart3:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate4:
    ldx #4
    cpx konamistate ; state up up down down
    bne kstate5
    ldy konamilastkey
    cpy #4 ; pressed left
    beq kpart4
    jmp resetstate
kpart4:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate5:
    ldx #5
    cpx konamistate ; state up up down down left
    bne kstate6
    ldy konamilastkey
    cpy #6 ; pressed right
    beq kpart5
    jmp resetstate
kpart5:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate6:
    ldx #6
    cpx konamistate ; state up up down down left right
    bne kstate7
    ldy konamilastkey
    cpy #4 ; pressed left
    beq kpart6
    jmp resetstate
kpart6:
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate7:
    ldx #7
    cpx konamistate ; state up up down down left right left
    bne kstate8
    ldy konamilastkey
    cpy #6 ; pressed right
    bne resetstate
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate8:
    ldx #8
    cpx konamistate ; state up up down down left right left right
    bne kstate9
    ldy konamilastkey
    cpy #7 ; pressed B
    bne resetstate
    inx ; increment state 
    stx konamistate
    jmp endkstates    
kstate9:
    ldx #9
    cpx konamistate ; state up up down down left right left right b 
    bne endkstates
    ldy konamilastkey
    cpy #9 ; pressed A
    bne resetstate
    inx ; increment state 
    stx konamistate
    jmp endkstates    
resetstate:
    lda #0
    sta konamistate
    ; ----------------------    
endkstates:
    rts
	;---------------------------------------------------
processkonamicode:
	; sequence for code: up (1), up (2), down (3), down (4), left (5), right (6), 
	;                    left (5), right (7), b (8), a (9), start (10)
	; konami key codes are: Left(4),Right(6),Up(8),Down(2),B(7),A(9),Start(5)
	; 3 variables available	"konamistate,konamikey,konamilastkey"
	
	; for it to work they must hold then release each character in sequence before
	; preceding to next
	
	; How it works: 
	; 1. get the keypress information and store it in konamikey
    ; 2. if (konamikey) { konamilastkey = konamikey; }
    ; 3. if (konamikey==0 && konamilastkey != 0) { updatestate; konamilastkey = 0; }
	    
	lda #0
    sta pressingstart
    lda #0
    sta konamikey
    
	lda #$01    ; |
	sta $4016   ;  \
	lda #$00    ;   - Setup Pad for reading.
	sta $4016   ; _/
	
	lda $4016  ; read for A key.
	and #1 
	beq afterkonamia
	lda #9
	sta konamikey
afterkonamia:
	lda $4016  ; read for B key.
	and #1 
	beq afterkonamib
	lda #7
	sta konamikey
afterkonamib:	
	lda $4016  ; read for SELECT
	lda $4016  ; read START status
	and #1
	beq afterkonamistart ; not pressing start jump to afterkonamistart
	lda #1 				
	sta pressingstart
	lda #5
	sta konamikey
afterkonamistart:	
	lda $4016  ; read UP
	and #1 
	beq afterkonamiup
	lda #8
	sta konamikey
afterkonamiup:	
	lda $4016  ; read DOWN
	and #1 
	beq afterkonamidown
	lda #2
	sta konamikey
afterkonamidown:	
	lda $4016  ; read LEFT
	and #1 
	beq afterkonamileft
	lda #4
	sta konamikey
afterkonamileft:	
	lda $4016  ; read RIGHT
	and #1 
	beq afterkonamiright
	lda #6
	sta konamikey
afterkonamiright:	
    ; if konamikey is 0, they weren't pressing anything except maybe select
    lda konamikey
    bne konamicontinue ; they were pressing something
    ; not pressing anything
    lda konamilastkey
    beq konamiend
    ; lastkey was something, and nothing is being pressed so change state
    ; run through the states and test conditions
    jsr dokonamistatemachine
    ; reset konamilastkey
    lda #0
    sta konamilastkey
    jmp konamiend
konamicontinue: 
    ; they are pressing something 
    lda konamikey
    sta konamilastkey
    ; -----------------------    
    ldx konamistate ; they are pressing start
    cpx #10 ; state 10
    bne konamiend
    ;;stx debugvar
    lda pressingstart
    beq konamiend
    ; in state 10 and pressing start
    jsr playhitsound
    lda #1
    sta showhidden
    lda #0
    sta konamistate
    lda #1 				; don't want the game to start so wait
    sta holdingstart
konamiend:
	rts
	;---------------------------------------------------
displayeasteregg:
    ; display the easter egg screen
    ; wait for start to be released, then wait for start again to return 
    ; to title screen
    rts
	;---------------------------------------------------
playtitlesound:
	; play a sound when the user wins game or starts game
	lda #$FF
	sta $4000
	lda #%11011011
	sta $4001
	lda #$A5
	sta $4002
	lda #$AB
	sta $4003
	rts
playhitsound:
	pha
	lda #$84
	sta $4000
	lda #$AA
	sta $4002
	lda #$09
	sta $4003
	pla
	rts
playmisssound:
	pha
	lda #$86
	sta $4000
	lda #$6A
	sta $4002
	lda #$08
	sta $4003
	pla
	rts	
	;---------------------------------------------------
displaytitlescreen:
	ldx #$00
	lda #$20		; PPU BG address is $2000
	sta $2006		; give $2006 both parts of address $2000.
	stx $2006 

  	lda #low(titlemap)  ; put the high and low bytes of the address "backg"
  	sta addrLO        	; into the variables so we can use indirect addressing.
  	lda #high(titlemap)
  	sta addrHI

	ldx #4  		; number of 256-byte chunks to load
  	ldy #0
dts_loop:
  	lda [addrLO],y
  	sta $2007       ; load 256 bytes
  	iny
  	bne dts_loop
  	inc addrHI		; increment high byte of address backg to next 256 byte chunk
  	dex       		; one chunk done so X = X - 1.
  	bne dts_loop 	; if X isn't zero, do again	
	rts
	;---------------------------------------------------
displayhiddenscreen:
	ldx #$00
	lda #$20		; PPU BG address is $2000
	sta $2006		; give $2006 both parts of address $2000.
	stx $2006 

  	lda #low(hiddenmap)  ; put the high and low bytes of the address "backg"
  	sta addrLO        	; into the variables so we can use indirect addressing.
  	lda #high(hiddenmap)
  	sta addrHI

	ldx #4  		; number of 256-byte chunks to load
  	ldy #0
dhs_loop:
  	lda [addrLO],y
  	sta $2007       ; load 256 bytes
  	iny
  	bne dhs_loop
  	inc addrHI		; increment high byte of address backg to next 256 byte chunk
  	dex       		; one chunk done so X = X - 1.
  	bne dhs_loop 	; if X isn't zero, do again	
	rts
	;---------------------------------------------------
turnonppuwithsprites:
	lda #%00001000  ; do the setup of PPU (bg $0000, spr $1000)
	sta $2000       
	lda #%00011110  ; spr on, bg on, no clip sp/bg
	sta $2001       
	rts		
	;---------------------------------------------------
turnonppunosprites:
	lda #%00001000  ; do the setup of PPU (bg $0000, spr $1000)
	sta $2000       
	lda #%00001110  ; spr on, bg on, no clip sp/bg
	sta $2001       
	rts		
	;---------------------------------------------------
turnoffppu:
	lda #%00000000  ; spr off, bg off
	sta $2001       
	rts		
	;---------------------------------------------------
clearscreen:
	ldx #$00
	lda #$20		; PPU BG address is $2000
	sta $2006		; give $2006 both parts of address $2000.
	stx $2006 
	ldx #4  		; number of 256-byte chunks to load
  	ldy #0
  	lda #$00		; data to be written
cb_loop:
  	sta $2007       ; load 256 bytes
  	iny
  	bne cb_loop
  	dex       		; one chunk done so X = X - 1.
  	bne cb_loop 	; if X isn't zero, do again	
	rts
    ;---------------------------------------------------
dogameover:
	lda #0			; kill the user, set the bit to wait for them to press start
	sta useralive	; to cycle back to the title screen
	; change the text at the bottom to say game over
	ldx #71			; G is 71d	
	stx spr11t
	ldx #65			; A is 65d
	stx spr12t
	ldx #77			; M is 77d
	stx spr13t
	ldx #69			; E is 69d
	stx spr14t
	ldx #79			; O is 79d
	stx spr15t
	ldx #86			; V is 86d
	stx spr16t
	ldx #69			; E is 69d
	stx spr17t
	ldx #82			; R is 82d
	stx spr18t
	; move game over from the bottom to the middle
	ldy #95
	sty spr11y
	sty spr12y
	sty spr13y
	sty spr14y
	sty spr15y
	sty spr16y
	sty spr17y
	sty spr18y
	; move the ball, and clear the tile
	ldx #5
	stx ballx
	stx bally
	ldx #0
	stx spr4t	; change ball tile to blank
	; change the player tiles in some way
	ldx #1
	stx spr5s
	stx spr6s
	stx spr7s
	stx spr8s
	stx spr9s
	stx spr10s
	rts
    ;---------------------------------------------------
dowingame:
	lda #0			; kill the user, set the bit to wait for them to press start
	sta useralive	; to cycle back to the title screen
	; change the text at the bottom to say game over
	ldx #89			; Y is 89d	
	stx spr11t
	ldx #79			; O is 79d
	stx spr12t
	ldx #85			; U is 85d
	stx spr13t
	ldx #32			; SPACE is 32d
	stx spr14t
	ldx #87			; W is 87d
	stx spr15t
	ldx #79			; O is 79d
	stx spr16t
	ldx #78			; N is 78d
	stx spr17t
	ldx #32			; diamond tile
	stx spr18t
	; move game over from the bottom to the middle
	ldy #95
	sty spr11y
	sty spr12y
	sty spr13y
	sty spr14y
	sty spr15y
	sty spr16y
	sty spr17y
	sty spr18y
	; move the ball, and clear the tile
	ldx #5
	stx ballx
	stx bally
	ldx #0
	stx spr4t	; change ball tile to blank
	; change the player tiles in some way
	ldx #2
	stx spr5s
	stx spr6s
	stx spr7s
	stx spr8s
	stx spr9s
	stx spr10s
	rts
    ;---------------------------------------------------
doballtesting:
	; 4 Parts to TESTING
    ; 1. if ball x = 0, bounce off left wall
	; 2. if ball x = 248, bounce off right wall
	; 3. if ball y = 1, dont hit the ceiling
	; 4. if ball y > 180, then check if on top of player
	;    - if between player 16 pixels, then change direction, increase score
	;    - if not game over
    ;---------------------------------------------------
    ; Assumptions, since ball moves every cycle, it will only be 0 or 248 for 
    ; once cycle, on the next cycle, after I change the movement it will move
    ; away from the wall. So only certain directions could have moved it 
    ; towards the wall. For instance 0 is left, 248 is right. 
    ; Possible EXCEPTION when ball reaches ceiling, so check those boundary cases
    ;---------------------------------------------------
    ; 1. if ball x = 0, bounce off left wall
	; POSSIBLE DIRECTIONS: up left, up, up right, down left, down, down right
	; VARIABLE DEFINES   :       0,  1,        2,         3,    4,          5
part1testing:    
	ldx #0				; if x = 0, else goto part2
	cpx ballx
	bne part2testing
	jsr playhitsound	; playsound if hit the leftwall
	ldx #0				; if direction = up left
	cpx ballDIR
	beq part1upleft
	ldx #3				; if direction = down left
	cpx ballDIR
	beq part1downleft
	; no fall through case, if x = 0 they should be going upleft or downleft
	; could reorder the conditions to remove the jump...save every last space in rom :)
	jmp part2testing	; goto part2
part1upleft:			; change upleft to be upright
	ldx #2
	stx ballDIR
	jmp part2testing
part1downleft:			; change downleft to be downright
	ldx #5
	stx ballDIR
	jmp part2testing	; unnecessary but funny instruction
    ;---------------------------------------------------
	; 2. if ball x = 248, bounce off right wall
part2testing:			
	ldx #248			; if x = 248, else goto part3
	cpx ballx
	bne part3testing
	jsr playhitsound	; playsound if hit the rightwall
	ldx #2				; if direction = up right
	cpx ballDIR
	beq part2upright
	ldx #5				; if direction = down right
	cpx ballDIR
	beq part2downright
	; missing fall thru case
	jmp part3testing	; goto part3
part2upright:			; change upright to be upleft
	ldx #0
	stx ballDIR
	jmp part3testing
part2downright:			; change downright to be downleft
	ldx #3
	stx ballDIR
	jmp part3testing
    ;---------------------------------------------------
	; 3. if ball y = 1, dont hit the ceiling
part3testing:
	ldy #1				; if y = 1, else goto part4
	cpy bally
	bne part4testing
	jsr playhitsound	; playsound if hit the ceiling
    ldx #0				; if dir = upleft 
    cpx ballDIR
    beq part3upleft
    ldx #2				; if dir = upright
    cpx ballDIR
    beq part3upright
    ; missing fall thru case
    jmp part3special0
part3upleft:			; upleft changes to downleft
	ldx #3
	stx ballDIR
	jmp part3special0
part3upright:			; upright changes to downright
	ldx #5
	stx ballDIR
	jmp part3special0
part3special0: 			;special case 0 and 248
	ldx #0				
	cpx ballx
	bne part3special248
	; if y = 1, x = 0, dir = down right
	ldx #5
	stx ballDIR
part3special248:	
	ldx #248
	cpx ballx
	bne part4testing
	; if y = 1, x = 248, dir = down left
	ldx #3
	stx ballDIR
    ;---------------------------------------------------
	; 4. if ball y > 180, then check if on top of player
	;    - if between player 16 pixels, then change direction, increase score, hit sound
	;    - if not game over, miss sound
	; As long as the ball only ever moves 1 pixel at a time
	; then I only have to check 180, actually 180-8 since the ball is 8 pixels tall
part4testing:	
	ldy #172			; if y != 172 we are done testing
	cpy bally
	bne endpart4
	; The player is two tiles wide or 16 pixels, the ball is 8 pixels wide
	; In order to make a hit at least two of the ball pixels must 
	; be in the 16 pixel range. So the test could be:
	; if ( (ballx > (playerx - 6)) & (ballx < (playerx+16+6)) ) THEN HIT
	;---------------------------------------------------
	; EXCEPTIONS: boundary walls - addition that wraps around is scary!
	; Then only one condition needs testing
	; so if playerx < 7 ---> ballx < playerx+16+6
	; so if playerx > 249, ---> ballx > playerx-6
	;---------------------------------------------------
	; I coded the above didn't work, so I coded based on testinbox
	; Old code was 25 non working instructions, new is 12! and it works!
	lda playermiddlex
	adc #8
	bcc part4leftx
	lda #255
part4leftx:	
	sbc ballx
	bmi part4missball
	lda ballx
	adc #16
	bcc part4rightx
	lda #255
part4rightx:
	sbc playerx
	bmi part4missball
	; otherwise fallthrough to part4hitball
	;---------------------------------------------------
	; they hit the ball so let it bounce back up and play hit sound
part4hitball:
	; change the direction of the ball 
	; ball direction is based on is the ballx > (playerx+8) = up right
	; otherwise up left
	ldx playermiddlex	; playerx+8 = playermiddlex
	cpx ballx			; compare to ballx
	bcs part4upleft		; if playerx+8 is bigger, then go upleft
	ldx #2				; upright
	stx ballDIR
	jmp part4afterchange
part4upleft:	
	ldx #0				; upleft
	stx ballDIR
part4afterchange:	
	; play hit sound
	jsr playhitsound	
	; increment the score
	; we can just keep the score in the tile numbers
	; just increment them if it becomes to large, inc next column, etc. 
	ldx score1s		; DO the first digit
	inx
	cpx #58			; is it greater than ascii for 9 then reset
	beq reset1s
	stx score1s		; otherwise store the incremented version back
	jmp endpart4
reset1s:
	ldx #48			; tile for 0
	stx score1s	
	ldx score10s	; do the 10s digit
	inx
	cpx #58
	beq reset10s
	stx score10s
	jmp endpart4
reset10s:
	ldx #48			; tile for 0
	stx score10s	
	ldx score100s	; do the 100s digit
	inx
	cpx #58
	beq reset100s
	stx score100s
	jmp endpart4
reset100s:
	jsr playtitlesound
	jsr dowingame
	jmp endpart4
	;ldx #48			; tile for 0
	;stx score100s	
	;---------------------------------------------------
	; else GAMEOVER! and SOUND UGLY NOISE
part4missball:
	jsr playmisssound	; make sound
	jsr dogameover		; change text to game over
endpart4:	 
	rts
	;---------------------------------------------------
	;---------------------------------------------------
	; data to be stored in ROM
	;---------------------------------------------------
	;---------------------------------------------------
tilepal: 
	.incbin "ball.pal" ; include and label our pallete
titlemap:
	.incbin "balls.map" ; include the map for the title screen
hiddenmap:
	.incbin "ballh.map" ; include the map for the title screen
	
	;---------------------------------------------------
	.bank 2   ; switch to bank 2
	.org $0000  ; start at $0000
	;---------------------------------------------------
	.incbin "ball.bkg"  ; background first
	.incbin "ball.spr"  ; our sprite pic data
	; note these MUST be in that order. (because of 
	; the way we setup the PPU)
	;---------------------------------------------------

